//------------------------------------------------------------------------------
//    : key.c
//       : Է Ű ó(ܺ ͷƮ, 4X4 Key Matrix)
//    :  (cycos21@naver.com)
//    : 2007 10 28
//    : 
//    : 
//       :  Key Matrix ̱ 
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <irq.h>
#include <timer.h>
#include <main.h>

#include <stdio.h>

#include <key.h>

static u8 led3_flag;
static u8 led2_flag;


//------------------------------------------------------------------------------
//  : ܺ IRQ0 ͷƮ ó ڵ鷯
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void ext_irq0_handler(void)
{
	unsigned int dummy;
	
	if(!led3_flag){
		led_on(LED3);
	}
	else 
	{
		led_off(LED3);
	}
	led3_flag = !led3_flag ;
	AIC_EOICR = dummy;	//End of Interrupt
}


//------------------------------------------------------------------------------
//  : ܺ FIQ ͷƮ ó ڵ鷯
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void ext_fiq_handler(void)
{
	unsigned int dummy;
	if(!led2_flag){
		led_on(LED2);
	}
	else 
	{
		led_off(LED2);
	}
	led2_flag = !led2_flag ;
	AIC_EOICR = dummy;	//End of Interrupt
}

/*
//------------------------------------------------------------------------------
//  : ܺ PIOB ͷƮ ʱȭ
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
//PIOB interrupt 
void ext_interrupt_init(void)
{
	unsigned int dummy;
	dummy = PIOB_ISR;	//ͷƮ Ŭ
	dummy = dummy;		//compile warning  

	led3_flag = 0;
	
	//#define EXT_FIQ			(PIO_PB19)
	//#define EXT_IRQ		(PIO_PB20)	
	PIOB_PER = (EXT_FIQ|EXT_IRQ);	//PIO
	PIOB_ODR = (EXT_FIQ|EXT_IRQ);	//Է 
//	PIOB_PUER = (EXT_FIQ|EXT_IRQ); 	//pull-up
	PIOB_IFER =  (EXT_FIQ|EXT_IRQ);
	PIOB_IER = (EXT_FIQ|EXT_IRQ); 	//ͷƮ  

	irq_request( ID_PIOB, AIC_SRCTYPE_HIGH_LEVEL, ext_irq_handler ); // ͷƮ ڵ鷯 
	irq_active( ID_PIOB );                   // Ÿ̸ ͷƮ 㰡
	led_on(LED1);
} 
*/

//------------------------------------------------------------------------------
//  : ܺ ͷƮ ġ ʱȭ 
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void ext_interrupt_init(void)
{
	unsigned int dummy;
		
	led2_flag = 0;
	led3_flag = 0;

	PMC_PCER = 1 << ID_IRQ0;
	PMC_PCER = 1 << ID_FIQ;

	dummy = dummy;		//compile warning  

	PIOB_PDR = (EXT_FIQ|EXT_IRQ);	//peripheral  
	PIOB_ASR = (EXT_FIQ|EXT_IRQ);	//Peripheral A  


//	printf("0. AIC_FVR :%X, fiq_handler :%0X, AIC_SVR : %0X\n", AIC_FVR, (u32)ext_fiq_handler, AIC_SVR);	
	irq_request( ID_FIQ, AIC_SRCTYPE_EXT_NEGATIVE_EDGE, ext_fiq_handler ); // ͷƮ ڵ鷯 
	irq_active( ID_FIQ );                   // FIQ ͷƮ 㰡
//	printf("1. AIC_FVR :%X, fiq_handler :%0X, AIC_SVR : %0X\n", AIC_FVR, (u32)ext_fiq_handler, AIC_SVR);
	
	
	irq_request( ID_IRQ0, AIC_SRCTYPE_EXT_NEGATIVE_EDGE, ext_irq0_handler ); // ͷƮ ڵ鷯 
	irq_active( ID_IRQ0 );                   // IRQ0 ͷƮ 㰡

	irq_enable();
	
	//led_on(LED1);
}

/*
//ʿϸ   ּ
void key_matrix_init(void)
{

}

//ʿϸ   ּ
u8 get_key(void)
{

}
*/
