
//------------------------------------------------------------------------------
//    : pck2.c
//      : Programmable clock 
//    : 뿵(ysroh@suv.ac.kr)
//    : 2007 11 12
//    : 
//    : 
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <main.h>

#include <stdio.h>

#include <etk.h>

#include <pck2.h>

//------------------------------------------------------------------------------
//  : Programmable clock ʱȭ Ѵ.
//        PCK2 = PLLCK / 8 = 96Mhz / 8 = 12MHz
// This code is not verified.
//------------------------------------------------------------------------------
void pck2_init( void )
{

//	PMC_PCER = 1 << ID_SYS;		// There is no effect, since the system controller is continuously clocked
								// See section 10.2 on page 35

	PIOB_PDR = PMC_PCK2;
	if(DEBUG) printf("DEBUG : PIOB_PSR = %x\n", PIOB_PSR);

	PIOB_ASR = PMC_PCK2;
	if(DEBUG) printf("DEBUG : PIOB_ABSR = %x\n", PIOB_ABSR);

	PMC_SCER = PMC_PCK2;
	if(DEBUG) printf("DEBUG : PMC_SCSR = %x\n", PMC_SCSR);

	PMC_PCKR2 = (PMC_CSS_PLL_CLK | PMC_PRES_CLK_8);
	if(DEBUG) printf("DEBUG : PMC_PCKR2 = %x\n", PMC_PCKR2);

	if(DEBUG) printf("DEBUG : PMC_SR = %x\n", PMC_SR);

	if(DEBUG) printf("DEBUG : Done, PCK2, Initialization\r\n");
	
}
