//------------------------------------------------------------------------------

//    : 7segment.h
//      : 7-Segent   
//    :  (cycos21@naver.com)
//    : 2007  9 28
//    : 2007 10  9, 뿵
//			1. 7-segment pin ġ 
//      :
//------------------------------------------------------------------------------


#ifndef _7SEGMENT_HEADER_
#define _7SEGMENT_HEADER_

//     a
//   0000
// f 0  0 b
//   0000<--g
// e 0  0 c
//   0000 0<--Dp
//     d
//	0 : on
// 	1 : off
//                         abcDpdefg
//                         7654 3210
#define	_7SEG_0		0x11 //0001 0001
#define	_7SEG_1		0x9f //1001 1111
#define	_7SEG_2		0x32 //0011 0010
#define	_7SEG_3		0x16 //0001 0110
#define	_7SEG_4		0x9c //1001 1100
#define	_7SEG_5		0x54 //0101 0100
#define	_7SEG_6		0x50 //0101 0000
#define	_7SEG_7		0x1d //0001 1101
#define	_7SEG_8		0x10 //0001 0000
#define	_7SEG_9		0x14 //0001 0100
#define	_7SEG_A 	0x18 //0001 1000
#define	_7SEG_B 	0xd0 //1101 0000
#define	_7SEG_C 	0x71 //0111 0001
#define	_7SEG_D 	0x92 //1001 0010
#define	_7SEG_E 	0x70 //0111 0000
#define	_7SEG_F 	0x78 //0111 1000


extern void SevenSeg_Init(void);

extern u8 Conv_To_7seg(u8 c);

extern char Serial_Display(u8 c);

#endif
