//------------------------------------------------------------------------------
//    : main.c
//      : AT91SAM7S512
//    :  (cycos21@naver.com)
//    : 2007 10 16
//    :
//    :
//      :
//------------------------------------------------------------------------------


#include <typedef.h>
#include <register.h>
#include <setup.h>

//------------------------------------------------------------------------------
//  : LED ʱȭ ڵ
//------------------------------------------------------------------------------
void leds_init( void )
{
	//	LED ʱȭ
	PIOA_PER  = (LED1|LED2|LED3);
	PIOA_OER  = (LED1|LED2|LED3);
	PIOA_SODR = (LED1|LED2|LED3);
}

//------------------------------------------------------------------------------
//  : LED ON
//------------------------------------------------------------------------------
void led_on( u32 led_value )
{
	PIOA_CODR = led_value;
}

//------------------------------------------------------------------------------
//  : LED OFF
//------------------------------------------------------------------------------
void led_off( u32 led_value )
{
	PIOA_SODR = led_value;
}

//------------------------------------------------------------------------------
//  : LED   Ų.
//------------------------------------------------------------------------------
void led_flash( void )
{
	volatile int lp;

	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;
	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;
	
}

//------------------------------------------------------------------------------
//  :  ƾ
//------------------------------------------------------------------------------
int main(void)
{
	leds_init();			// LEDʱȭ

	led_flash();			// LED ׽Ʈ
		
	return 0;
}


