//------------------------------------------------------------------------------
//    : 7segment.c
//       : 7-Segment ó 
//    :  (cycos21@naver.com)
//    : 2007 10 28
//    : 
//    : 
//       : 뿵   ڷ ҽڵ 
//------------------------------------------------------------------------------
#include <register.h>
#include <setup.h>
#include <typedef.h>

#include <etk.h>

#include <7segment.h>

static u8 DBof7Seg[]={ _7SEG_0, _7SEG_1, _7SEG_2, _7SEG_3, _7SEG_4, _7SEG_5,
				_7SEG_6, _7SEG_7, _7SEG_8, _7SEG_9, _7SEG_A, _7SEG_B, 
				_7SEG_C, _7SEG_D, _7SEG_E, _7SEG_F};


//------------------------------------------------------------------------------
//  : 7-Segment ʱȭ
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void SevenSeg_Init()
{
	PMC_PCER = (1 << ID_PIOB); //clock Ensble
	
	PIOB_PER  = (SHIFT_DATA|SHIFT_CLOCK|SEV_SEG_LATCH); 	//PIO  
	PIOB_OER  = (SHIFT_DATA|SHIFT_CLOCK|SEV_SEG_LATCH);	//PIO   
}


//------------------------------------------------------------------------------
//  : 7-Segment ° ȯ 
// Ű : ȯ 16  
// ȯ :  
//  :  4Ʈ  
//------------------------------------------------------------------------------
u8 Conv_To_7seg(u8 c)
{
	c = c & 0x0f; //LNIBBLE;

	return(DBof7Seg[(int)c]);
}


//------------------------------------------------------------------------------
//  : 7-Segment 
// Ű :  16  
// ȯ :  
//  : 
//------------------------------------------------------------------------------
char Serial_Display(u8 c)
{
	char i, t;

	for (i=8;i;i--) 
	{
		t = c;
		t &= 0x80;
		if(t)								// data out
			PIOB_SODR = SHIFT_DATA;
		else
			PIOB_CODR = SHIFT_DATA;
			
		PIOB_SODR = SHIFT_CLOCK;		// shift clock out
		PIOB_CODR = SHIFT_CLOCK;
		c <<= 1;
	}
	
	PIOB_SODR = SEV_SEG_LATCH;				// latch clock out
	PIOB_CODR = SEV_SEG_LATCH;

	return 1;
}
