//------------------------------------------------------------------------------
//    : main.c
//      : AT91SAM7S512
//    :  (cycos21@naver.com)
//    : 2007 10 16
//    :
//    :
//      :
//------------------------------------------------------------------------------


#include <typedef.h>
#include <register.h>
#include <setup.h>

#include <irq.h>

#include <main.h>

#include <key.h>

//------------------------------------------------------------------------------
//  : LED   Ų.
//------------------------------------------------------------------------------
void leds_init( void )
{
	//	LED ʱȭ
	PIOA_PER  = (LED1|LED2|LED3);
	PIOA_OER  = (LED1|LED2|LED3);
	PIOA_SODR = (LED1|LED2|LED3);
}

void led_on( u32 led_value )
{
	PIOA_CODR = led_value;
}

void led_off( u32 led_value )
{
	PIOA_SODR = led_value;
}

void led_flash( void )
{
	volatile int lp;

	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;
	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;

}


//------------------------------------------------------------------------------
//  :  ƾ
//------------------------------------------------------------------------------
int main(void)
{
	volatile int lp;

	leds_init();			// LEDʱȭ
	irq_init();			// IRQ ͷƮ ó ʱȭ
	
	led_flash();			// LED ׽Ʈ

	ext_interrupt_init();		//ܺ ͷƮ ʱȭ 
	
		
	while(1)
	{
	led_on(LED1);  for( lp = 0; lp < 0x80000; lp++ ) ;
	led_off(LED1); for( lp = 0; lp < 0x80000; lp++ ) ;	
		

	}//END while
		
	return 0;
}


